package scripts;

import com.stencyl.graphics.G;

import com.stencyl.behavior.Script;
import com.stencyl.behavior.ActorScript;
import com.stencyl.behavior.SceneScript;
import com.stencyl.behavior.TimedTask;

import com.stencyl.models.Actor;
import com.stencyl.models.GameModel;
import com.stencyl.models.actor.Animation;
import com.stencyl.models.actor.ActorType;
import com.stencyl.models.actor.Collision;
import com.stencyl.models.actor.Group;
import com.stencyl.models.Scene;
import com.stencyl.models.Sound;
import com.stencyl.models.Region;
import com.stencyl.models.Font;

import com.stencyl.Engine;
import com.stencyl.Input;
import com.stencyl.utils.Utils;

import nme.ui.Mouse;
import nme.display.Graphics;
import nme.display.BlendMode;
import nme.events.Event;
import nme.events.TouchEvent;
import nme.net.URLLoader;

import motion.Actuate;
import motion.easing.Back;
import motion.easing.Cubic;
import motion.easing.Elastic;
import motion.easing.Expo;
import motion.easing.Linear;
import motion.easing.Quad;
import motion.easing.Quart;
import motion.easing.Quint;
import motion.easing.Sine;



class Design_34_34_FollowTarget extends ActorScript
{          	
	
public var _TargetActor:Actor;

public var _DistanceX:Float;

public var _DistanceY:Float;

public var _Distance:Float;

public var _Direction:Float;

public var _Speed:Float;

public var _Margin:Float;

public var _Easing:Bool;

public var _MinimumEasingSpeed:Float;

public var _ScreenDiagonal:Float;

public var _StopwhenColliding:Bool;

public var _Collided:Bool;

 
 	public function new(dummy:Int, actor:Actor, engine:Engine)
	{
		super(actor, engine);	
		nameMap.set("Target Actor", "_TargetActor");
nameMap.set("Distance X", "_DistanceX");
_DistanceX = 0.0;
nameMap.set("Distance Y", "_DistanceY");
_DistanceY = 0.0;
nameMap.set("Distance", "_Distance");
_Distance = 0.0;
nameMap.set("Direction", "_Direction");
_Direction = 0.0;
nameMap.set("Speed", "_Speed");
_Speed = 30.0;
nameMap.set("Margin", "_Margin");
_Margin = 0.0;
nameMap.set("Easing", "_Easing");
_Easing = true;
nameMap.set("Minimum Easing Speed", "_MinimumEasingSpeed");
_MinimumEasingSpeed = 5.0;
nameMap.set("Screen Diagonal", "_ScreenDiagonal");
_ScreenDiagonal = 0.0;
nameMap.set("Stop when Colliding", "_StopwhenColliding");
_StopwhenColliding = true;
nameMap.set("Collided", "_Collided");
_Collided = false;
nameMap.set("Actor", "actor");

	}
	
	override public function init()
	{
		            _ScreenDiagonal = asNumber(Math.sqrt((Math.pow(getScreenWidth(), 2) + Math.pow(getScreenHeight(), 2))));
propertyChanged("_ScreenDiagonal", _ScreenDiagonal);
    addWhenUpdatedListener(null, function(elapsedTime:Float, list:Array<Dynamic>):Void {
if(wrapper.enabled){
        if(((hasValue(_TargetActor) != false) && _TargetActor.isAlive()))
{
            _DistanceX = asNumber((_TargetActor.getXCenter() - actor.getXCenter()));
propertyChanged("_DistanceX", _DistanceX);
            _DistanceY = asNumber((_TargetActor.getYCenter() - actor.getYCenter()));
propertyChanged("_DistanceY", _DistanceY);
            _Distance = asNumber(Math.sqrt((Math.pow(_DistanceX, 2) + Math.pow(_DistanceY, 2))));
propertyChanged("_Distance", _Distance);
            _Direction = asNumber(Utils.DEG * (Math.atan2(_DistanceY, _DistanceX)));
propertyChanged("_Direction", _Direction);
            if(((_Distance > _Margin) && !((_StopwhenColliding && _Collided))))
{
                if(_Easing)
{
                    actor.setVelocity(_Direction, (_MinimumEasingSpeed + (_Speed * ((_Distance - _Margin) / _ScreenDiagonal))));
}

                else
{
                    actor.setVelocity(_Direction, _Speed);
}

}

            else
{
                actor.setVelocity(0, 0);
}

            _Collided = false;
propertyChanged("_Collided", _Collided);
}

}
});
    addCollisionListener(actor, function(event:Collision, list:Array<Dynamic>):Void {
if(wrapper.enabled && (_TargetActor == event.otherActor)){
        _Collided = true;
propertyChanged("_Collided", _Collided);
}
});

	}	      	
	
	override public function forwardMessage(msg:String)
	{
		
	}
}