package scripts;

import com.stencyl.graphics.G;

import com.stencyl.behavior.Script;
import com.stencyl.behavior.ActorScript;
import com.stencyl.behavior.SceneScript;
import com.stencyl.behavior.TimedTask;

import com.stencyl.models.Actor;
import com.stencyl.models.GameModel;
import com.stencyl.models.actor.Animation;
import com.stencyl.models.actor.ActorType;
import com.stencyl.models.actor.Collision;
import com.stencyl.models.actor.Group;
import com.stencyl.models.Scene;
import com.stencyl.models.Sound;
import com.stencyl.models.Region;
import com.stencyl.models.Font;

import com.stencyl.Engine;
import com.stencyl.Input;
import com.stencyl.utils.Utils;

import nme.ui.Mouse;
import nme.display.Graphics;
import nme.display.BlendMode;
import nme.events.Event;
import nme.events.TouchEvent;
import nme.net.URLLoader;

import motion.Actuate;
import motion.easing.Back;
import motion.easing.Cubic;
import motion.easing.Elastic;
import motion.easing.Expo;
import motion.easing.Linear;
import motion.easing.Quad;
import motion.easing.Quart;
import motion.easing.Quint;
import motion.easing.Sine;



class Design_8_8_Wander extends ActorScript
{          	
	
public var _MinimumMovingTime:Float;

public var _MaximumMovingTime:Float;

public var _MinimumWaitingTime:Float;

public var _MaximumWaitingTime:Float;

public var _StartwithWaiting:Bool;

public var _MaximumSpeed:Float;

public var _Wait:Bool;

public var _Move:Bool;

public var _MinimumSpeed:Float;

public var _ChangeDirectionwhenColliding:Bool;

public var _SpeedY:Float;

public var _SpeedX:Float;

 
 	public function new(dummy:Int, actor:Actor, engine:Engine)
	{
		super(actor, engine);	
		nameMap.set("Minimum Moving Time", "_MinimumMovingTime");
_MinimumMovingTime = 1.0;
nameMap.set("Maximum Moving Time", "_MaximumMovingTime");
_MaximumMovingTime = 2.0;
nameMap.set("Minimum Waiting Time", "_MinimumWaitingTime");
_MinimumWaitingTime = 1.0;
nameMap.set("Maximum Waiting Time", "_MaximumWaitingTime");
_MaximumWaitingTime = 2.0;
nameMap.set("Start with Waiting", "_StartwithWaiting");
_StartwithWaiting = true;
nameMap.set("Maximum Speed", "_MaximumSpeed");
_MaximumSpeed = 10.0;
nameMap.set("Wait", "_Wait");
_Wait = false;
nameMap.set("Move", "_Move");
_Move = false;
nameMap.set("Minimum Speed", "_MinimumSpeed");
_MinimumSpeed = 5.0;
nameMap.set("Change Direction when Colliding", "_ChangeDirectionwhenColliding");
_ChangeDirectionwhenColliding = true;
nameMap.set("Actor", "actor");
nameMap.set("Speed Y", "_SpeedY");
_SpeedY = 0.0;
nameMap.set("Speed X", "_SpeedX");
_SpeedX = 0.0;

	}
	
	override public function init()
	{
		            _Wait = _StartwithWaiting;
propertyChanged("_Wait", _Wait);
        _Move = !(_StartwithWaiting);
propertyChanged("_Move", _Move);
    addWhenUpdatedListener(null, function(elapsedTime:Float, list:Array<Dynamic>):Void {
if(wrapper.enabled){
        if(_Wait)
{
            _Wait = false;
propertyChanged("_Wait", _Wait);
            runLater(1000 * (_MinimumWaitingTime + (randomFloat() * (_MaximumWaitingTime - _MinimumWaitingTime))), function(timeTask:TimedTask):Void {
                        _Move = true;
propertyChanged("_Move", _Move);
}, actor);
            actor.setVelocity(0, 0);
            _SpeedX = asNumber(0);
propertyChanged("_SpeedX", _SpeedX);
            _SpeedY = asNumber(0);
propertyChanged("_SpeedY", _SpeedY);
}

        if(_Move)
{
            _Move = false;
propertyChanged("_Move", _Move);
            runLater(1000 * (_MinimumMovingTime + (randomFloat() * (_MaximumMovingTime - _MinimumMovingTime))), function(timeTask:TimedTask):Void {
                        _Wait = true;
propertyChanged("_Wait", _Wait);
}, actor);
            actor.setVelocity(randomInt(Math.floor(-180), Math.floor(180)), randomInt(Math.floor(_MinimumSpeed), Math.floor(_MaximumSpeed)));
            _SpeedX = asNumber(actor.getXVelocity());
propertyChanged("_SpeedX", _SpeedX);
            _SpeedY = asNumber(actor.getYVelocity());
propertyChanged("_SpeedY", _SpeedY);
}

}
});
    addCollisionListener(actor, function(event:Collision, list:Array<Dynamic>):Void {
if(wrapper.enabled){
        if(_ChangeDirectionwhenColliding)
{
            if((event.thisFromLeft || event.thisFromRight))
{
                actor.setXVelocity(-(_SpeedX));
}

            if((event.thisFromTop || event.thisFromBottom))
{
                actor.setYVelocity(-(_SpeedY));
}

}

}
});

	}	      	
	
	override public function forwardMessage(msg:String)
	{
		
	}
}